import java.awt.Color;

import javax.swing.SpinnerNumberModel;

public class KubomakiData {
	//===============================================萔
	//
	//----------------------------------Z[ut@C̃p[^[w
	//
	static final String MARK_BK_SP="back_speed";
	static final String MARK_BK_COL="back_color";
	static final String MARK_CL_TIM="clear_times";
	static final String MARK_LF_NUM="life_number";
	static final String MARK_SF_SP="self_speed";
	static final String MARK_EC_DEL_DIS="echo_delete_distance";
	static final String MARK_EC_SPC="echo_space";
	static final String MARK_EC_NUM="echo_number";
	static final String MARK_EN_NUM="enemy_number";
	static final String MARK_EN_SP_MAX="enemy_speed_max";
	static final String MARK_EN_SP_MIN="enemy_speed_min";
	static final String MARK_NS_DEL_DIS="noise_delete_distance";
	static final String MARK_NS_SPC="noise_space";
	static final String MARK_NS_NUM="noise_number";
	static final String MARK_FR_NUM="friend_number";
	static final String MARK_FR_SP_MAX="friend_speed_max";
	static final String MARK_FR_SP_MIN="friend_speed_min";
	static final String MARK_BGM="bgm";
	static final String MARK_SE="se";
	//
	//----------------------------------Xe[Wp[^[̊{ݒ
	//
	static final String[] BASE_STAGE_NAME={"0","1","2","3"};
	//S
	static final int[] BASE_BACK_SPEED={9,9,9,9};	//֗鑬
	static final Color[] BASE_BACK_COLOR={Color.decode("#000000"),Color.decode("#feb447"),Color.decode("#000000"),Color.decode("#4073ad")};	//wiF
	//
	static final int[] BASE_CLEAR_TIMES={10,10,10,10};		//Xe[WNÄׂ̒ʉ߉
	static final int[] BASE_LIFE_NUMBER={5,5,5,5};			//ő̐_
	//
	static final int[] BASE_SELF_SPEED={12,12,12,12};		//P̈ړ
	//
	static final int[] BASE_ECHO_DELETE_DISTANCE={60,60,60,60};	//GR[̏
	static final int[] BASE_ECHO_SPACE={5,5,5,5};					//GR[̔ˊԊu
	static final int[] BASE_ECHO_NUMBER={5,5,5,5};					//GR[̂P̔ˌ
	//G
	static final int[] BASE_ENEMY_NUMBER={10,10,12,15};	//Ǧ
	static final int[] BASE_ENEMY_SPEED_MAX={8,8,8,8};		//őړx
	static final int[] BASE_ENEMY_SPEED_MIN={4,4,4,4};		//ŏړx
	//
	static final int[] BASE_NOISE_DELETE_DISTANCE={500,500,500,500};	//dg̏
	static final int[] BASE_NOISE_SPACE={5,5,5,5};						//dg̔ˊԊu
	static final int[] BASE_NOISE_NUMBER={8,8,10,12};					//dĝP̔
	//̑
	static final int[] BASE_FRIEND_NUMBER={20,20,25,30};		//̑̌
	static final int[] BASE_FRIEND_SPEED_MAX={8,8,8,8};		//őړx
	static final int[] BASE_FRIEND_SPEED_MIN={4,4,4,4};		//ŏړx
	//
	static final String[] BASE_BGM={"bgm01","bgm01","bgm02","bgm03"};
	static final String[] BASE_SE={"audio","audio","audio","audio"};
	//
	//----------------------------------pӂꂽXe[W̃Zbg
	//setNum
	static final int SETNUM_MAKE=0;
	static final int SETNUM_1=1;
	static final int SETNUM_2=2;
	static final int SETNUM_3=3;
	static final int SETNUM_ALL=4;
	//iȉAz̒g͊{ݒ̓YŎw肵Ăj
	static final int[/*setNum*/] SET_STAGE_START={1,1,1,1,1};
	static final int[/*setNum*/] SET_STAGE_END={1,1,1,1,3};
	//
	static final String[/*setNum*/][/*stageNow-1*/] SET_STAGE_NAME={
			{"0","0","0"},
			{"1","0","0"},
			{"2","0","0"},
			{"3","0","0"},
			{"1/3","2/3","3/3"},
	};
	//
	static final int[/*setNum*/][/*stageNow-1*/] SET_STAGE_PARAM={
			{0,0,0},
			{1,0,0},
			{2,0,0},
			{3,0,0},
			{1,2,3},
	};
	//
	//===============================================ϐ
	//
	//----------------------------------ʍ
	//Zbgԍ
	int setNum;
	/*Xe[W쐬ŕXe[W𓱓ΕKvɂȂ
	int stageStart;
	int stageEnd;
	*/
	//݂̃Xe[W
	int stageNow;
	//
	int score;			//_
	int lifeMax;		//ő吶_ilifeNumberƂQdɂȂĂ̂œׂł͂j
	double lifeNow;	//c萶_
	//----------------------------------Xe[W̃p[^[
	//
	String stageName;
	//
	int backSpeed;
	Color backColor;

	int clearTimes;
	int lifeNumber;

	int selfSpeed;

	int echoDeleteDistance;
	int echoSpace;
	int echoNumber;

	int enemyNumber;
	int enemySpeedMax;
	int enemySpeedMin;

	int noiseDeleteDistance;
	int noiseSpace;
	int noiseNumber;

	int friendNumber;
	int friendSpeedMax;
	int friendSpeedMin;

	String BGM;
	String SE;
	//-----------------------------------
	//ݒt@C̕񂩂KvȒloi[Ăꎞϐ
	String tmpName;
	String tmpValueString;
	int tmpValueInt;
	Color tmpValueColor;
	//-------------------------------------------
	//
	//-------------------------------------------
	public KubomakiData(){
		//
	}
	//----------------------------------------------------
	//pӂꂽXe[W
	//----------------------------------------------------
	//ZbgI
	public void selectSet(int set){
		//
		setNum=set;
		//
		firstStage();	//selectStage()
		//
		formatCommonData();
	}
	//Xe[WI
	public void selectStage(){
		//
		stageName=SET_STAGE_NAME[setNum][stageNow-1];
		//
		backSpeed=BASE_BACK_SPEED[ SET_STAGE_PARAM[setNum][stageNow-1] ];
		backColor=BASE_BACK_COLOR[ SET_STAGE_PARAM[setNum][stageNow-1] ];

		clearTimes=BASE_CLEAR_TIMES[ SET_STAGE_PARAM[setNum][stageNow-1] ];
		lifeNumber=BASE_LIFE_NUMBER[ SET_STAGE_PARAM[setNum][stageNow-1] ];

		selfSpeed=BASE_SELF_SPEED[ SET_STAGE_PARAM[setNum][stageNow-1] ];

		echoDeleteDistance=BASE_ECHO_DELETE_DISTANCE[ SET_STAGE_PARAM[setNum][stageNow-1] ];
		echoSpace=BASE_ECHO_SPACE[ SET_STAGE_PARAM[setNum][stageNow-1] ];
		echoNumber=BASE_ECHO_NUMBER[ SET_STAGE_PARAM[setNum][stageNow-1] ];

		enemyNumber=BASE_ENEMY_NUMBER[ SET_STAGE_PARAM[setNum][stageNow-1] ];
		enemySpeedMax=BASE_ENEMY_SPEED_MAX[ SET_STAGE_PARAM[setNum][stageNow-1] ];
		enemySpeedMin=BASE_ENEMY_SPEED_MIN[ SET_STAGE_PARAM[setNum][stageNow-1] ];

		noiseDeleteDistance=BASE_NOISE_DELETE_DISTANCE[ SET_STAGE_PARAM[setNum][stageNow-1] ];
		noiseSpace=BASE_NOISE_SPACE[ SET_STAGE_PARAM[setNum][stageNow-1] ];
		noiseNumber=BASE_NOISE_NUMBER[ SET_STAGE_PARAM[setNum][stageNow-1] ];

		friendNumber=BASE_FRIEND_NUMBER[ SET_STAGE_PARAM[setNum][stageNow-1] ];
		friendSpeedMax=BASE_FRIEND_SPEED_MAX[ SET_STAGE_PARAM[setNum][stageNow-1] ];
		friendSpeedMin=BASE_FRIEND_SPEED_MIN[ SET_STAGE_PARAM[setNum][stageNow-1] ];

		BGM=BASE_BGM[ SET_STAGE_PARAM[setNum][stageNow-1] ];
		SE=BASE_SE[ SET_STAGE_PARAM[setNum][stageNow-1] ];
	}
	//----------------------------------------------------
	//ʍڂ̏
	//----------------------------------------------------
	public void formatCommonData(){
		//iΕsvɂȂ邩j
		lifeMax=lifeNumber;
		//
		lifeNow=lifeMax-0.5;
		score=0;
	}
	//----------------------------------------------------
	//
	//----------------------------------------------------
	//imakeł͎gȂj
	public void firstStage(){
		stageNow=SET_STAGE_START[setNum];
		selectStage();
	}
	public void nextStage(){
		stageNow++;
		selectStage();
	}
	//
	public boolean checkAllClear(){
		if(stageNow>=SET_STAGE_END[setNum]){
			return true;
		}else{
			return false;
		}
	}
	public boolean checkMaked(){
		if(setNum==SETNUM_MAKE){
			return true;
		}else{
			return false;
		}
	}
	//----------------------------------------------------
	//Xe[W쐬̃vC
	//----------------------------------------------------
	public void makeStage(KubomakiMake make){
		//
		setNum=SETNUM_MAKE;
		//
		stageNow=SET_STAGE_START[setNum];	//firstStage()ł͂ȂiXe[W쐬łselectStage()Ȃj
		//
		//ׂĂ̍ڂ𓖂Ă͂߂̂ŁAȌ͕sv
		//
		backSpeed=make.spnBkSp.getNumber().intValue();
		backColor=make.btnColor.getBackground();
		//
		clearTimes=make.spnClTim.getNumber().intValue();
		lifeNumber=make.spnLfNum.getNumber().intValue();
		//
		stageName=make.txtName.getText();
		//
		selfSpeed=make.spnSfSp.getNumber().intValue();
		//
		echoDeleteDistance=make.spnEcDelDis.getNumber().intValue();
		echoSpace=make.spnEcSpc.getNumber().intValue();
		echoNumber=make.spnEcNum.getNumber().intValue();
		//
		enemyNumber=make.spnEnNum.getNumber().intValue();
		enemySpeedMax=make.spnEnSpdMax.getNumber().intValue();
		enemySpeedMin=make.spnEnSpdMin.getNumber().intValue();
		//
		noiseDeleteDistance=make.spnNsDelDis.getNumber().intValue();
		noiseSpace=make.spnNsSpc.getNumber().intValue();
		noiseNumber=make.spnNsNum.getNumber().intValue();
		//
		friendNumber=make.spnFrdNum.getNumber().intValue();
		friendSpeedMax=make.spnFrdSpdMax.getNumber().intValue();
		friendSpeedMin=make.spnFrdSpdMin.getNumber().intValue();
		//
		BGM=make.cmbBGM.getSelectedItem().toString();
		SE=make.cmbSE.getSelectedItem().toString();
		//
		formatCommonData();
	}
	//----------------------------------------------------
	//Z[u
	//----------------------------------------------------
	public String getSaveString(KubomakiMake make){
		//Z[uf[^쐬
		String br=System.getProperty("line.separator");
		StringBuilder ret=new StringBuilder();
		//
		ret.append(MARK_BK_SP).append("(").append( make.spnBkSp.getNumber().intValue() ).append(")").append(br);
		ret.append(MARK_BK_COL).append("(").append( Integer.toHexString(make.btnColor.getBackground().getRGB()).substring(2) ).append(")").append(br);
		ret.append(br);
		ret.append(MARK_CL_TIM).append("(").append( make.spnClTim.getNumber().intValue() ).append(")").append(br);
		ret.append(MARK_LF_NUM).append("(").append( make.spnLfNum.getNumber().intValue() ).append(")").append(br);
		ret.append(br);
		ret.append(MARK_SF_SP).append("(").append( make.spnSfSp.getNumber().intValue() ).append(")").append(br);
		ret.append(br);
		ret.append(MARK_EC_DEL_DIS).append("(").append( make.spnEcDelDis.getNumber().intValue() ).append(")").append(br);
		ret.append(MARK_EC_SPC).append("(").append( make.spnEcSpc.getNumber().intValue() ).append(")").append(br);
		ret.append(MARK_EC_NUM).append("(").append( make.spnEcNum.getNumber().intValue() ).append(")").append(br);
		ret.append(br);
		ret.append(MARK_EN_NUM).append("(").append( make.spnEnNum.getNumber().intValue() ).append(")").append(br);
		ret.append(MARK_EN_SP_MAX).append("(").append( make.spnEnSpdMax.getNumber().intValue() ).append(")").append(br);
		ret.append(MARK_EN_SP_MIN).append("(").append( make.spnEnSpdMin.getNumber().intValue() ).append(")").append(br);
		ret.append(br);
		ret.append(MARK_NS_DEL_DIS).append("(").append( make.spnNsDelDis.getNumber().intValue() ).append(")").append(br);
		ret.append(MARK_NS_SPC).append("(").append( make.spnNsSpc.getNumber().intValue() ).append(")").append(br);
		ret.append(MARK_NS_NUM).append("(").append( make.spnNsNum.getNumber().intValue() ).append(")").append(br);
		ret.append(br);
		ret.append(MARK_FR_NUM).append("(").append( make.spnFrdNum.getNumber().intValue() ).append(")").append(br);
		ret.append(MARK_FR_SP_MAX).append("(").append( make.spnFrdSpdMax.getNumber().intValue() ).append(")").append(br);
		ret.append(MARK_FR_SP_MIN).append("(").append( make.spnFrdSpdMin.getNumber().intValue() ).append(")").append(br);
		ret.append(br);
		ret.append(MARK_BGM).append("(").append( make.cmbBGM.getSelectedItem().toString() ).append(")").append(br);
		ret.append(MARK_SE).append("(").append( make.cmbSE.getSelectedItem().toString() ).append(")").append(br);
		//
		return ret.toString();
	}
	//----------------------------------------------------
	//[h
	//----------------------------------------------------
	public void setLoadString(String name,String[] ld,KubomakiMake make){
		//plɔf邾Ȃ̂ŁAق̕ϐ͂ȂĂ
		//
		//炩ߏlKiw̍ڂ邩Ȃj
		setStageDef();
		//data̕ϐɈꎞIɊi[
		//
		stageName=name;
		//
		if(ld.length>0){
			//
			for(int i=0;i<ld.length;i++){
				if(takeoutDataToString(ld[i])){
					if(tmpName.equals(MARK_BK_SP)){
						if(changeStringToInt(tmpValueString)){	backSpeed=tmpValueInt;	}
					}else if(tmpName.equals(MARK_BK_COL)){
						if(changeStringToColor(tmpValueString)){	backColor=tmpValueColor;	}
					}else if(tmpName.equals(MARK_CL_TIM)){
						if(changeStringToInt(tmpValueString)){	clearTimes=tmpValueInt;	}
					}else if(tmpName.equals(MARK_LF_NUM)){
						if(changeStringToInt(tmpValueString)){	lifeNumber=tmpValueInt;	}
					}else if(tmpName.equals(MARK_SF_SP)){
						if(changeStringToInt(tmpValueString)){	selfSpeed=tmpValueInt;	}
					}else if(tmpName.equals(MARK_EC_DEL_DIS)){
						if(changeStringToInt(tmpValueString)){	echoDeleteDistance=tmpValueInt;	}
					}else if(tmpName.equals(MARK_EC_SPC)){
						if(changeStringToInt(tmpValueString)){	echoSpace=tmpValueInt;	}
					}else if(tmpName.equals(MARK_EC_NUM)){
						if(changeStringToInt(tmpValueString)){	echoNumber=tmpValueInt;	}
					}else if(tmpName.equals(MARK_EN_NUM)){
						if(changeStringToInt(tmpValueString)){	enemyNumber=tmpValueInt;	}
					}else if(tmpName.equals(MARK_EN_SP_MAX)){
						if(changeStringToInt(tmpValueString)){	enemySpeedMax=tmpValueInt;	}
					}else if(tmpName.equals(MARK_EN_SP_MIN)){
						if(changeStringToInt(tmpValueString)){	enemySpeedMin=tmpValueInt;	}
					}else if(tmpName.equals(MARK_NS_DEL_DIS)){
						if(changeStringToInt(tmpValueString)){	noiseDeleteDistance=tmpValueInt;	}
					}else if(tmpName.equals(MARK_NS_SPC)){
						if(changeStringToInt(tmpValueString)){	noiseSpace=tmpValueInt;	}
					}else if(tmpName.equals(MARK_NS_NUM)){
						if(changeStringToInt(tmpValueString)){	noiseNumber=tmpValueInt;	}
					}else if(tmpName.equals(MARK_FR_NUM)){
						if(changeStringToInt(tmpValueString)){	friendNumber=tmpValueInt;	}
					}else if(tmpName.equals(MARK_FR_SP_MAX)){
						if(changeStringToInt(tmpValueString)){	friendSpeedMax=tmpValueInt;	}
					}else if(tmpName.equals(MARK_FR_SP_MIN)){
						if(changeStringToInt(tmpValueString)){	friendSpeedMin=tmpValueInt;	}
					}else if(tmpName.equals(MARK_BGM)){
						BGM=tmpValueString;
					}else if(tmpName.equals(MARK_SE)){
						SE=tmpValueString;
					}
				}
			}
		}
		//͈͂`FbNplɔfidata̕ϐւ̔f̓vCł͂Ȃ̂ŕsvj
		//
		make.txtName.setText(stageName);
		//
		if( checkLimit(make.spnBkSp,backSpeed) ){				backSpeed=make.spnBkSp.getNumber().intValue();	}
		make.btnColor.setBackground(backColor);
		//
		if( checkLimit(make.spnClTim,clearTimes) ){				clearTimes=make.spnClTim.getNumber().intValue();	}
		if( checkLimit(make.spnLfNum,lifeNumber) ){				lifeNumber=make.spnLfNum.getNumber().intValue();	}
		//
		if( checkLimit(make.spnSfSp,selfSpeed) ){				selfSpeed=make.spnSfSp.getNumber().intValue();			}
		//
		if( checkLimit(make.spnEcDelDis,echoDeleteDistance) ){	echoDeleteDistance=make.spnEcDelDis.getNumber().intValue();		}
		if( checkLimit(make.spnEcSpc,echoSpace) ){				echoSpace=make.spnEcSpc.getNumber().intValue();	}
		if( checkLimit(make.spnEcNum,echoNumber) ){				echoNumber=make.spnEcNum.getNumber().intValue();	}
		//iőlŏl̏ꍇ肤邪Aœ삳̂ʔ̂ŕuj
		if( checkLimit(make.spnEnNum,enemyNumber) ){			enemyNumber=make.spnEnNum.getNumber().intValue();			}
		if( checkLimit(make.spnEnSpdMax,enemySpeedMax) ){		enemySpeedMax=make.spnEnSpdMax.getNumber().intValue();	}
		if( checkLimit(make.spnEnSpdMin,enemySpeedMin) ){		enemySpeedMin=make.spnEnSpdMin.getNumber().intValue();	}
		//
		if( checkLimit(make.spnNsDelDis,noiseDeleteDistance) ){	noiseDeleteDistance=make.spnNsDelDis.getNumber().intValue();	}
		if( checkLimit(make.spnNsSpc,noiseSpace) ){				noiseSpace=make.spnNsSpc.getNumber().intValue();	}
		if( checkLimit(make.spnNsNum,noiseNumber) ){			noiseNumber=make.spnNsNum.getNumber().intValue();	}
		//
		if( checkLimit(make.spnFrdNum,friendNumber) ){			friendNumber=make.spnFrdNum.getNumber().intValue();			}
		if( checkLimit(make.spnFrdSpdMax,friendSpeedMax) ){		friendSpeedMax=make.spnFrdSpdMax.getNumber().intValue();	}
		if( checkLimit(make.spnFrdSpdMin,friendSpeedMin) ){		friendSpeedMin=make.spnFrdSpdMin.getNumber().intValue();	}
		//
		make.cmbBGM.setSelectedItem(BGM);
		make.cmbSE.setSelectedItem(SE);
	}
	//[hf[^͈͓ɒ
	private boolean checkLimit(SpinnerNumberModel snm,int param){
		if(param>(int)(snm.getMaximum())){
			snm.setValue(snm.getMaximum());
			return true;
		}else if(param<(int)(snm.getMinimum())){
			snm.setValue(snm.getMinimum());
			return true;
		}else{
			snm.setValue(param);
			return false;
		}
	}
	//li{ݒ0jɐݒ
	private void setStageDef(){
		//
		stageName=BASE_STAGE_NAME[0];
		//
		backSpeed=BASE_BACK_SPEED[0];
		backColor=BASE_BACK_COLOR[0];

		clearTimes=BASE_CLEAR_TIMES[0];
		lifeNumber=BASE_LIFE_NUMBER[0];

		selfSpeed=BASE_SELF_SPEED[0];

		echoDeleteDistance=BASE_ECHO_DELETE_DISTANCE[0];
		echoSpace=BASE_ECHO_SPACE[0];
		echoNumber=BASE_ECHO_NUMBER[0];

		enemyNumber=BASE_ENEMY_NUMBER[0];
		enemySpeedMax=BASE_ENEMY_SPEED_MAX[0];
		enemySpeedMin=BASE_ENEMY_SPEED_MIN[0];

		noiseDeleteDistance=BASE_NOISE_DELETE_DISTANCE[0];
		noiseSpace=BASE_NOISE_SPACE[0];
		noiseNumber=BASE_NOISE_NUMBER[0];

		friendNumber=BASE_FRIEND_NUMBER[0];
		friendSpeedMax=BASE_FRIEND_SPEED_MAX[0];
		friendSpeedMin=BASE_FRIEND_SPEED_MIN[0];

		BGM=BASE_BGM[0];
		SE=BASE_SE[0];
	}
	//------------------------------------------
	//nꂽʂ̌^ɕϊitrueԂAʂꎞϐɊi[j
	//------------------------------------------
	private boolean changeStringToColor(String data){
		try{
			tmpValueColor = Color.decode("0x"+data);
			return true;
		}catch(NumberFormatException e){
			return false;
		}
	}
	private boolean changeStringToInt(String data){
		try{
			tmpValueInt = Integer.parseInt(data);
			return true;
		}catch(NumberFormatException e){
			return false;
		}
	}
	//-------------------------------------------
	//ݒ蕶̃JbR݂̂oitrueԂAʂꎞϐɊi[j
	//-------------------------------------------
	private boolean takeoutDataToString(String data){
		//JnJbRȂAw薼Ȃ
		int index1=data.indexOf('(');
		if(index1==-1 || index1==0){	return false;	}
		//JbRȂAJbR̒gȂ
		int index2=data.indexOf(')',index1);
		if(index2==-1 || index2==index1+1){	return false;	}
		//
		tmpName=data.substring(0,index1);
		tmpValueString=data.substring(index1+1,index2);
		return true;
	}
}
