import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

public class KubomakiPlay implements ActionListener {
	//===============================================萔
	//SelfAOthersAEnemy̏
	static final int S_LIVE=0;	//S큄
	static final int S_DYING=1;	//Enemyj
	static final int S_DEATH=2;	//Self_[WAOthersAEnemyjい
	static final int S_END=3;	//OthersEnemyI
	//modePlay
	static final int MP_START=0;			//
	static final int MP_PLAY=1;			//vC
	static final int MP_STAGECLEAR=2;	//Xe[WNA[
	static final int MP_ALLCLEAR=3;		//SXe[WNA[
	static final int MP_GAMEOVER=4;		//Q[I[o[
	static final int MP_TEMPSTOP=5;		//ꎞ~
	//
	//===============================================ϐ
	//
	KubomakiPanel panel;
	KubomakiData data;
	KubomakiSound sounds;
	//
	KubomakiSelf self;			//
	KubomakiEnemy enemy[];		//G̔z
	KubomakiOthers others[];	//̑̔z
	KubomakiBack back;			//wi
	//
	//ړƔ˂̃tO
	boolean shooting;
	boolean go_up;
	boolean go_down;
	boolean go_left;
	boolean go_right;
	//V[eBȌ
	int modePlay;
	//
	//------------------------------------------------
	//
	//------------------------------------------------
	public KubomakiPlay(KubomakiPanel p,KubomakiData d,KubomakiSound s){
		//
		modePlay=MP_START;		//
		//
		panel=p;
		data=d;
		sounds=s;
	}
	//-------------------------------------------
	//Xe[W
	//-------------------------------------------
	public void formatStage(){
		//
		//iɗOmodePlay͐ݒς݂̂͂j
		//
		sounds.formatSound(data);
		//
		//tO
		shooting=false;
		go_up=false;
		go_down=false;
		go_left=false;
		go_right=false;
		//
		//̏
		self=new KubomakiSelf(data);
		//G̏
		enemy=new KubomakiEnemy[data.enemyNumber];	//
		for(int e=0;e<enemy.length;e++){
			enemy[e]=new KubomakiEnemy(data);
		}
		//̑̏
		others=new KubomakiOthers[data.friendNumber];	//
		for(int o=0;o<others.length;o++){
			others[o]=new KubomakiOthers(data);
		}
		//wȉ
		back=new KubomakiBack(data);
		//ԂłȂBGMt
		if(modePlay!=MP_START){
			sounds.loopBGM();
		}
	}
	//------------------------------------------------
	//`
	//------------------------------------------------
	public void paint(Graphics g){
		//
		//----퓬ʂ̕`----
		//wi̕`
		back.backPaint(g,data.backColor);
		//̑̕`
		for(int o=0;o<others.length;o++){	//
			others[o].othersPaint(g);
		}
		//G̕`
		for(int e=0;e<enemy.length;e++){	//
			enemy[e].enemyPaint(g,data.backColor);
		}
		//ԂłȂ
		if(modePlay!=MP_START){
			//̕`
			self.selfPaint(g,data.backColor);
		}
		//----\̕`----
		//hԂ
		g.setColor(Color.lightGray);
		g.fillRect(0, KubomakiPanel.F_HEIGHT, KubomakiPanel.F_WIDTH, 50);
		//XRAECt̕
		g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 30));
		g.setColor(Color.black);
		g.drawString("SCORE:",KubomakiPanel.F_WIDTH/4-120,KubomakiPanel.F_HEIGHT_PLUS-15);
		g.drawString("LIFE:",KubomakiPanel.F_WIDTH/2,KubomakiPanel.F_HEIGHT_PLUS-15);
		//_\
		g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 40));
		g.setColor(Color.magenta);
		g.drawString(""+data.score,KubomakiPanel.F_WIDTH/4,KubomakiPanel.F_HEIGHT_PLUS-10);
		//c胉Ct
		g.setColor(Color.yellow);
		for(int l=1;l<=data.lifeMax;l++){
			if(data.lifeNow>=l){
				g.fillRoundRect(KubomakiPanel.F_WIDTH/2+40+40*l,KubomakiPanel.F_HEIGHT_PLUS-30,30,10,8,8);
			}else if(data.lifeNow>l-1){		//o
				g.fillRoundRect(KubomakiPanel.F_WIDTH/2+40+40*l-5,KubomakiPanel.F_HEIGHT_PLUS-35,40,20,8,8);
			}else{
				g.drawRoundRect(KubomakiPanel.F_WIDTH/2+40+40*l,KubomakiPanel.F_HEIGHT_PLUS-30,30,10,8,8);
			}
		}
		//ʒ
		g.setColor(Color.red);
		//
		switch(modePlay){
		case MP_GAMEOVER:			//Q[I[o[
			g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 100));
			g.drawString("Game Over",KubomakiPanel.F_WIDTH/2-50*5,KubomakiPanel.F_HEIGHT_PLUS/2-50);
			//
			g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 50));
			g.drawString("click:give up",KubomakiPanel.F_WIDTH/2-25*6,KubomakiPanel.F_HEIGHT_PLUS/2+0);
			g.drawString("+Shift:continue(same satage)",KubomakiPanel.F_WIDTH/2-25*14,KubomakiPanel.F_HEIGHT_PLUS/2+50);
			g.drawString("+Control:continue(first Stage)",KubomakiPanel.F_WIDTH/2-25*15,KubomakiPanel.F_HEIGHT_PLUS/2+100);
			break;
		case MP_STAGECLEAR:		//Xe[WNA[
			g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 100));
			g.drawString("Stage Clear",KubomakiPanel.F_WIDTH/2-50*5,KubomakiPanel.F_HEIGHT_PLUS/2-50);
			//
			g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 50));
			g.drawString("click:next stage",KubomakiPanel.F_WIDTH/2-25*7,KubomakiPanel.F_HEIGHT_PLUS/2+0);
			break;
		case MP_ALLCLEAR:			//SXe[WNA[
			g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 100));
			g.drawString("All Clear",KubomakiPanel.F_WIDTH/2-50*4,KubomakiPanel.F_HEIGHT_PLUS/2-50);
			//
			g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 50));
			g.drawString("click:finish",KubomakiPanel.F_WIDTH/2-25*6,KubomakiPanel.F_HEIGHT_PLUS/2+0);
			g.drawString("+Control:once more",KubomakiPanel.F_WIDTH/2-25*9,KubomakiPanel.F_HEIGHT_PLUS/2+50);
			break;
		case MP_START:			//
			g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 100));
			g.drawString("stage "+data.stageName,KubomakiPanel.F_WIDTH/2-50*5,KubomakiPanel.F_HEIGHT_PLUS/2-50);
			//
			g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 50));
			g.drawString("click:start",KubomakiPanel.F_WIDTH/2-25*6,KubomakiPanel.F_HEIGHT_PLUS/2+0);
			break;
		case MP_TEMPSTOP:			//ꎞ~
			g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 100));
			g.drawString("ꎞ~",KubomakiPanel.F_WIDTH/2-50*5,KubomakiPanel.F_HEIGHT_PLUS/2-50);
			//
			g.setFont(new Font( g.getFont().getName(), Font.ITALIC|Font.BOLD, 50));
			g.drawString("Space:ĊJ",KubomakiPanel.F_WIDTH/2-25*5,KubomakiPanel.F_HEIGHT_PLUS/2+0);
			break;
		default:
			//no work
		}
	}
	//------------------------------------------------
	//}EXCxg
	//------------------------------------------------
	public void mouseClicked(MouseEvent e){		//}EXNbN
		switch(modePlay){
		case MP_START:			//̃Xe[WvCJn
			//Xe[WύXȂ
			modePlay=MP_PLAY;
			formatStage();
			break;
		case MP_STAGECLEAR:		//̃Xe[W
			data.nextStage();				//Xe[WύX
			modePlay=MP_START;
			formatStage();
			break;
		case MP_ALLCLEAR:			//ŏ̃Xe[W
			if(e.isControlDown()){			//ŏ̃Xe[W蒼(Control)
				continueFromFirstStage();
			}else{							//I
				modePlay=MP_START;				//***߂Ă***
				if(data.checkMaked()){
					panel.backFromPlayToMake();
				}else{
					panel.backFromPlayToTitle();
				}
			}
			break;
		case MP_GAMEOVER:
			if(e.isShiftDown()){			//̃Xe[WReBj[(Shift)
				//Xe[WύXȂimakełj
				data.formatCommonData();		//XRAƃCt
				modePlay=MP_START;
				formatStage();
			}else if(e.isControlDown()){	//ŏ̃Xe[W蒼(Control)
				continueFromFirstStage();
			}else{							//MuAbv
				modePlay=MP_START;				//***߂Ă***
				if(data.checkMaked()){
					panel.backFromPlayToMake();
				}else{
					panel.backFromPlayToTitle();
				}
			}
			break;
		case MP_PLAY:
			break;
		case MP_TEMPSTOP:
			break;
		default:
			//no work
		}
	}
	//ŏ̃Xe[W蒼imakeƋʂŎgj
	private void continueFromFirstStage(){
		if(!data.checkMaked()){				//imakeł̓Xe[W͒PƂŁAselectStage()Ȃj
			data.firstStage();		//Xe[WύXiselectStage()Ăj
		}
		data.formatCommonData();	//XRAƃCt
		modePlay=MP_START;
		formatStage();
	}
	//------------------------------------------------
	//L[Cxg
	//------------------------------------------------
	public void keyPressed(KeyEvent e){	//L[
		//ɃQ[I[o[Ȃ牽Ȃ
		if(modePlay==MP_GAMEOVER){	return;	}
		//tO𗧂ĂiL[ňړAShiftL[Ŕˁj
        switch(e.getKeyCode()){
        case KeyEvent.VK_UP:	go_up=true;		break;	//L[
        case KeyEvent.VK_DOWN:	go_down=true;	break;	//L[
        case KeyEvent.VK_LEFT:	go_left=true;	break;	//L[
        case KeyEvent.VK_RIGHT:	go_right=true;	break;	//EL[
        case KeyEvent.VK_SHIFT:	shooting=true;	break;	//VtgL[
        case KeyEvent.VK_Z:								//ZL[ij
			//_[WȂ畜
			if(self.mode==KubomakiPlay.S_DEATH){
				data.lifeNow-=0.5;
				sounds.playSE(KubomakiSound.SE_BE);
				self.go();
			}
			break;
        case KeyEvent.VK_SPACE:							//SpaceL[iꎞ~EĊJj
			if(modePlay==MP_PLAY){
				sounds.stopBGM();
				modePlay=MP_TEMPSTOP;
				//
				panel.suspendPlay();
			}else if(modePlay==MP_TEMPSTOP){
				sounds.loopBGM();
				modePlay=MP_PLAY;
				//
				panel.suspendPlay();
			}
			break;
       }
    }
	public void keyReleased(KeyEvent e){	//L[
		//ɃQ[I[o[Ȃ牽Ȃ
		if(modePlay==MP_GAMEOVER){	return;	}
		//tO낷
        switch(e.getKeyCode()){
        case KeyEvent.VK_UP:	go_up=false;	break;	//L[
        case KeyEvent.VK_DOWN:	go_down=false;	break;	//L[
        case KeyEvent.VK_LEFT:	go_left=false;	break;	//L[
        case KeyEvent.VK_RIGHT:	go_right=false;	break;	//EL[
        case KeyEvent.VK_SHIFT:	shooting=false;	break;	//ShiftL[
		}
	}
	//------------------------------------------------
	//Timeȑ
	//------------------------------------------------
	public void actionPerformed(ActionEvent ae) {
		//
		//BackAEnemyAOthers̎Ԑis
		back.time();
		for(int e=0;e<enemy.length;e++){	//
			enemy[e].time(self.mode,sounds);
		}
		for(int o=0;o<others.length;o++){	//
			others[o].time(self.mode);
		}
		//ݒłȂ
		if(modePlay!=MP_START){
			//Self̎Ԑis
			self.time();
			//tOɂăGR[
			if(shooting){	self.shoot(sounds);	}
			//tOɂSelfړ
			if(go_up){
				self.up();
				check(KubomakiSelf.C_UP);
			}
			if(go_down){
				self.down();
				check(KubomakiSelf.C_DOWN);
			}
			if(go_left){
				self.left();
				check(KubomakiSelf.C_LEFT);
			}
			if(go_right){
				self.right();
				check(KubomakiSelf.C_RIGHT);
			}
			//˂ĂΓGȆ̓蔻
			if(self.r1!=0){
				for(int e=0;e<enemy.length;e++){
					if( enemy[e].check(self.obx,self.oby,self.ocx,self.ocy,self.r1+self.num*self.uni) ){
						data.score+=50;
					}
				}
				for(int o=0;o<others.length;o++){
					if( others[o].check(self.obx,self.oby,self.ocx,self.ocy,self.r1+self.num*self.uni) ){
						sounds.playSE(KubomakiSound.SE_TURN);
						data.score+=10;
					}
				}
			}
			//̓蔻
			check(KubomakiSelf.C_TIME);
			//I
loop:		if(modePlay==MP_PLAY){		//܂Xe[WNA[ĂȂ
				for(int e=0;e<enemy.length;e++){
					if( enemy[e].checkEnd() ){	break loop;	}
				}
				for(int o=0;o<others.length;o++){
					if( others[o].checkEnd() ){	break loop;	}
				}
				//
				if(/*data.stageNow>=data.stageEnd*/data.checkAllClear()){
					modePlay=MP_ALLCLEAR;
					sounds.stopBGM();
					sounds.playSE(KubomakiSound.SE_CLEARALL);
				}else{
					modePlay=MP_STAGECLEAR;
					sounds.stopBGM();
					sounds.playSE(KubomakiSound.SE_CLEAR);
				}
			}
		}
		//
		panel.repaint();
	}
	//蔻
	private void check(int c){
		//Ƀ_[WȂΉȂ
		if(self.mode!=KubomakiPlay.S_LIVE){	return;	}
		//GƂ̓蔻
		for(int e=0;e<enemy.length;e++){
			if( self.check(enemy[e],c) ){
				sounds.playSE(KubomakiSound.SE_NOTBE);
				data.lifeNow-=0.5;
				if(data.lifeNow<=0){		//Q[I[o[
					modePlay=MP_GAMEOVER;
					sounds.stopBGM();
					sounds.playSE(KubomakiSound.SE_OVER);
				}
				return;		//
			}
		}
		//̑Ƃ̓蔻
		for(int o=0;o<others.length;o++){
			if( self.check(others[o],c) ){
				sounds.playSE(KubomakiSound.SE_NOTBE);
				data.lifeNow-=0.5;
				if(data.lifeNow<=0){		//Q[I[o[
					modePlay=MP_GAMEOVER;
					sounds.stopBGM();
					sounds.playSE(KubomakiSound.SE_OVER);
				}
				return;		//
			}
		}
	}

}
