//*************************************************************
//
//	@u@N{}L̖`@v version 1.4
//
//@@@@@@@@@@@@ҁF[g؁@@@
//@@@@@@@@@@쐬JnFQOOQ^R
//@@@@@@@@@@ŏIXVFQOPV^S   [TN029/J20]
//*************************************************************
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.Timer;

//C̃pl
public class KubomakiPanel extends JPanel
				 implements MouseListener,MouseMotionListener,KeyListener
{
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//===============================================
	//N
	public static void main(String[] args) {
		//t[
		JFrame frame=new JFrame("N{}L̖`");
		//
		//CNXłplAt[ɍڂ
		KubomakiPanel panel=new KubomakiPanel(frame);
		frame.getContentPane().add(panel);
		//
		frame.setResizable(false);		//TCYŒiTCYɎw肹˂Ε\ςɂȂj
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	//E~ŏI
		frame.setVisible(true);
		//t[TCY
		panel.fitFrameSize(frame);
		//
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//===============================================萔
	//plTCY
	static final int F_WIDTH=800;
	static final int F_HEIGHT=550;
	static final int F_HEIGHT_PLUS=600;
	//
	static final int UNIT=20;				//`Cxg̊P
	//tHg
	static final Font FONT_L=new Font(null,Font.BOLD | Font.ITALIC,UNIT*3);
	static final Font FONT_M=new Font(null,Font.PLAIN,UNIT*2);
	static final Font FONT_S=new Font(null,Font.BOLD,UNIT*1);
	//mode
	static final int M_TITLE=0;			//^Cg
	static final int M_PLAY=1;			//V[eBO
	static final int M_ADV=2;			//ViI
	static final int M_MAKE=3;			//Xe[W쐬
	//
	//===============================================ϐ
	JFrame frame;		//t[i\̍XV̂߂ɕKvj
	//
	KubomakiFileIO fileIO;	//
	KubomakiData data;		//
	KubomakiSound sounds;	//BGMƌʉ
	//ꂼ̏ʗp
	KubomakiPlay actPlay;	//
	KubomakiTitle actTitle;	//
	KubomakiMake actMake;	//
	KubomakiAdv actAdv;		//
	//
	Timer playTimer;	//V[eBOʂ̃^C}[iǗ̓CpanelłĂj
	//
	//ʂ̏
	int mode;
	//------------------------------------------------
	//
	//------------------------------------------------
	public KubomakiPanel(JFrame frame){
		//
		this.frame=frame;
		//
		this.setLayout(null);		//makẽplݒû߁ALayoutManager𖳌ɂ
		//
		//̏
		mode=M_TITLE;
		//
		fileIO=new KubomakiFileIO(frame,this);
		data=new KubomakiData();
		sounds=new KubomakiSound();
		//
		actPlay=new KubomakiPlay(this,data,sounds);
		playTimer=new Timer(100,actPlay);
		//
		actTitle=new KubomakiTitle(this);
		//
		actMake=new KubomakiMake(this,fileIO,data);
		//
		actAdv=new KubomakiAdv(this);
		//
		//Cxg̐ݒ
		addMouseListener(this);
		addMouseMotionListener(this);
		addKeyListener(this);
		//
	}
	//NɃt[̃TCY킹
	public void fitFrameSize(JFrame frame){
		int w=F_WIDTH-getSize().width;
		int h=F_HEIGHT_PLUS-getSize().height;
		frame.setSize(frame.getSize().width+w,frame.getSize().height+h);
		frame.setVisible(true);	//1sƃt[̃tB[hȂǂTCYȂiȂHj
	}
	//------------------------------------------------
	//ʂ̐؂ւ
	//------------------------------------------------
	//iplayTimeȑ̓CpanelōsĂj
	public void goFromTitleToPlay(int set){
		//
		data.selectSet(set);
		actPlay.formatStage();	//sounds.formatSound(data)
		//
		mode=M_PLAY;
		//
		playTimer.start();
	}
	public void backFromPlayToTitle(){
		//
		playTimer.stop();
		//
		mode=M_TITLE;
		//
		repaint();
	}
	//ꎞ~ƍĊJ
	public void suspendPlay(){
		if(playTimer.isRunning()){
			playTimer.stop();
			//
			repaint();
		}else{
			playTimer.start();
		}
	}
	//
	public void goFromTitleToMake(){
		//plݒu
		this.add(actMake.paramPanel);
		frame.setVisible(true);	//1sƃpl\ȂiȂHj
		//
		mode=M_MAKE;
		//
		repaint();
	}
	public void backFromMakeToTitle(){
		//plP
		this.remove(actMake.paramPanel);	//
		//
		mode=M_TITLE;
		//
		repaint();
	}
	//iplayTimeȑ̓CpanelōsĂj
	public void goFromMakeToPlay(){
		//plP
		this.remove(actMake.paramPanel);
		//
		//data͊ɓKς
		actPlay.formatStage();
		//
		mode=M_PLAY;
		//
		playTimer.start();
	}
	public void backFromPlayToMake(){
		//plݒu
		this.add(actMake.paramPanel);
		frame.setVisible(true);	//1sƃpl\ȂiȂHj
		//
		playTimer.stop();
		//
		mode=M_MAKE;
		//
		repaint();
	}
	//iadvTimeȑAdvNXōsĂj
	public void goFromTitleToAdv(int n){
		//
		actAdv.formatScenario(n);
		//
		mode=M_ADV;
	}
	public void backFromAdvToTitle(){
		//
		mode=M_TITLE;
		//
		repaint();
	}
	//------------------------------------------------
	//`
	//------------------------------------------------
	public void paintComponent(Graphics g){
		super.paintComponent(g);	//KviꂪȂƔwiFœhԂȂj
		//
		switch(mode){
		case M_PLAY:
			actPlay.paint(g);
			break;
		case M_TITLE:
			actTitle.paint(g);
			break;
		case M_MAKE:
			actMake.paint(g);
			break;
		case M_ADV:
			actAdv.paint(g);
			break;
		default:
			//
		}
	}
	//d˕
	public static void paintDoubleString(Graphics g,String str,int px,int py,Color fc,Color bc,int gap){
		g.setColor(bc);
		g.drawString(str,px+gap,py+gap);
		g.setColor(fc);
		g.drawString(str,px,py);
	}
	//------------------------------------------------
	//}EXCxg
	//------------------------------------------------
    public void mousePressed(MouseEvent e){}	//}EX{^
    public void mouseDragged(MouseEvent e){}	//}EXhbO
    public void mouseReleased(MouseEvent e){}	//}EX{^
	public void mouseEntered(MouseEvent e){}	//}EX
	public void mouseExited (MouseEvent e){}	//}EXo
	public void mouseMoved  (MouseEvent e){	//}EX𓮂
		//
		switch(mode){
		case M_PLAY:
			break;
		case M_TITLE:
			actTitle.mouseMoved(e);
			break;
		case M_MAKE:
			actMake.mouseMoved(e);
			break;
		case M_ADV:
			actAdv.mouseMoved(e);
			break;
		default:
			//
		}
	}
	public void mouseClicked(MouseEvent e){		//}EXNbN
		//L[Cxg󂯎邽߂ɃtH[JXĂ
		requestFocus();
		//
		switch(mode){
		case M_PLAY:
			actPlay.mouseClicked(e);
			break;
		case M_TITLE:
			actTitle.mouseClicked(e);
			break;
		case M_MAKE:
			actMake.mouseClicked(e);
			break;
		case M_ADV:
			actAdv.mouseClicked(e);
			break;
		default:

		}
	}
	//------------------------------------------------
	//L[Cxg
	//------------------------------------------------
	public void keyTyped   (KeyEvent e){}	//L[͂
	public void keyPressed(KeyEvent e){	//L[
		switch(mode){
		case M_PLAY:
			actPlay.keyPressed(e);
			break;
		case M_TITLE:
			break;
		case M_MAKE:
			break;
		case M_ADV:
			actAdv.keyPressed(e);
			break;
		default:

		}
    }
	public void keyReleased(KeyEvent e){	//L[
		switch(mode){
		case M_PLAY:
			actPlay.keyReleased(e);
			break;
		case M_TITLE:
			actTitle.keyReleased(e);
			break;
		case M_MAKE:
			actMake.keyReleased(e);
			break;
		case M_ADV:
			actAdv.keyReleased(e);
			break;
		default:

		}
	}
	//******************************************************************************************************
	//bZ[W\
	//------------------------------------------------------------------------------------------------------
	/*
	private void showInfoMessage(String message,String title){
		JOptionPane.showMessageDialog(this,	message,title,JOptionPane.INFORMATION_MESSAGE);
	}*/
	public void showErrorMessage(String message,String title){
		JOptionPane.showMessageDialog(this,	message,title,JOptionPane.ERROR_MESSAGE);
	}
	//------------------------------------------------
	//
	//------------------------------------------------
	public static int rnd(int r_min,int r_max){
		return (int)((r_max-r_min)*Math.random()+r_min);
	}
}
