import java.applet.Applet;
import java.applet.AudioClip;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

//ʉ̊ǗAt̃NXčs
public class KubomakiSound
{
	//===============================================萔
	//ʉ
	static final int SE_BE=0;		//self
	static final int SE_NOTBE=1;		//self_[W
	static final int SE_CLEAR=2;		//Xe[WNA[
	static final int SE_CLEARALL=3;	//SXe[WNA[
	static final int SE_OVER=4;		//Q[I[o[
	static final int SE_TURN=5;		//othersCɕԂ
	static final int SE_ECHO=6;		//selfGR[
	static final int SE_NOISE=7;		//enemydg
	static final int SE_CRASH=8;		//enemyj
	//
	static final int SE_ALL=9;
	//
	static final String[] SE_NAME={"be","notbe","clear","clearall","over","turn","echo","noise","crash"};
	//t@CtH_
	static final String FOLDER="audio";
	//===============================================ϐ
	//
	AudioClip bgm;
	AudioClip soundEffect[];
	//ttOiIt̋@\tꍇɔĎcj
	boolean playFlag;
	//
	//-------------------------------------
	//
	//-------------------------------------
	public KubomakiSound(){
		//
		playFlag=true;
		//
		soundEffect=new AudioClip[SE_ALL];
	}
	//-------------------------------------
	//t@C̓ǂݍ
	//-------------------------------------
	public void formatSound(KubomakiData data){
		if(playFlag){
			//
			if(data.checkMaked()){	//Xe[W쐬̏ꍇAÕt@C`FbN
				bgm=getOuterAudioClip(FOLDER+"/bgm",FOLDER+"/"+data.BGM+".au");
				for(int s=0;s<SE_ALL;s++){
					soundEffect[s]=getOuterAudioClip(FOLDER+"/"+SE_NAME[s],data.SE+"/"+SE_NAME[s]+".au");
				}
			}else{					//pӂꂽXe[W̏ꍇÃt@C
				bgm=getInnerAudioClip(FOLDER+"/"+data.BGM+".au");
				for(int s=0;s<SE_ALL;s++){
					soundEffect[s]=getInnerAudioClip(data.SE+"/"+SE_NAME[s]+".au");
				}
			}
		}
	}
	//
	private AudioClip getInnerAudioClip(String innerPathAll){
		//
		URL url=getClass().getResource(innerPathAll);
		return Applet.newAudioClip(url);
	}
	//OAȂΓ
	private AudioClip getOuterAudioClip(String outerPathNoEx,String innerPathAll){
		File file=getAudioFile(outerPathNoEx);
		if(file!=null){
			try{
				return Applet.newAudioClip(file.toURI().toURL());
			}catch(MalformedURLException e){
				return getInnerAudioClip(innerPathAll);	//G[Ȃ
			}

		}else{
			return getInnerAudioClip(innerPathAll);	//OɂȂΓ
		}
	}
	//Ot@C̗L`FbN
	private File getAudioFile(String outerPathNoEx){
		File file;
		//DxP
		file=new File(/*System.getProperty("user.dir")+"/"+*/outerPathNoEx+".au");
		if(file.exists()){	return file;	}
		//DxQ
		file=new File(/*System.getProperty("user.dir")+"/"+*/outerPathNoEx+".wav");
		if(file.exists()){	return file;	}
		//DxR
		file=new File(/*System.getProperty("user.dir")+"/"+*/outerPathNoEx+".mid");
		if(file.exists()){	return file;	}
		//
		return null;
	}
	//-------------------------------------
	//tp
	//-------------------------------------
	public synchronized void playSE(int soundNum){
		if(!playFlag){	return;	}
		//
		if(soundNum<SE_ALL){
			//
			soundEffect[soundNum].play();
		}
	}
	public void loopBGM(){
		if(!playFlag){	return;	}
		//
		bgm.loop();
	}
	public void stopBGM(){
		if(!playFlag){	return;	}
		//
		bgm.stop();
	}
}
